// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/components/display/Material.hpp"
#include "scene/components/display/mesh/MeshRenderer.hpp"

namespace Dawn {
  class SimpleBillboardedMaterial : public Material {
    private:
      shaderlock_t shaderLock = -1;

    public:
      // @optional
      Texture *texture = nullptr;
      // @optional
      struct Color color = COLOR_WHITE;

      /**
       * SimpleBillboardMaterial scene item component interface.
       * 
       * @param i Scene Item this interface belongs to.
       */
      SimpleBillboardedMaterial(SceneItem *i);

      void onStart() override;
      void onDispose() override;
      std::vector<struct ShaderPassItem> getRenderPasses(IRenderableContext &context) override;
  };
}