// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/components/entity/EntityMove.hpp"
#include "scene/components/entity/EntitySwordAttack.hpp"
#include "scene/components/entity/EntityShootingAttack.hpp"

namespace Dawn {
  class PlayerController : public SceneItemComponent {
    protected:
      EntityMove *entityMove = nullptr;
      EntitySwordAttack *entitySwordAttack = nullptr;
      EntityShootingAttack *entityShootingAttack = nullptr;

    public:
      PlayerController(SceneItem *item);
      std::vector<SceneItemComponent*> getDependencies() override;
      void onStart() override;
  };
}