/**
 * Copyright (c) 2022 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "assert.hpp"

void assertTrue(bool_t x, const char message[]) {
  if(x != true) {
    std::cout << message << std::endl;
    throw message;
    free(0);
  }
  assert(x == true);
}

void assertTrue(bool_t x, std::string message) {
  assertTrue(x, message.c_str());
}


void assertFalse(bool_t x, const char message[]) {
  assertTrue(!x, message);
}

void assertFalse(bool_t x, std::string message) {
  assertFalse(x, message.c_str());
}


void assertUnreachable(const char message[]) {
  assertTrue(false, message);
}

void assertUnreachable(std::string message) {
  assertUnreachable(message.c_str());
}


void assertNotNull(void *pointer, const char message[]) {
  assertTrue(pointer != nullptr && pointer != NULL, message);
}

void assertNotNull(void *pointer, std::string message) {
  assertNotNull(pointer, message.c_str());
}


void assertNull(void *pointer, const char message[]) {
  assertTrue(pointer == NULL || pointer == nullptr, message);
}

void assertNull(void *pointer, std::string message) {
  assertNull(pointer, message.c_str());
}


void assertDeprecated(const char message[]) {
  assertUnreachable(message);
}

void assertDeprecated(std::string message) {
  assertDeprecated(message.c_str());
}